import React from 'react';
import ReactDOM from 'react-dom';
import { Style } from 'radium';
import Theme from 'circuitsim-theme';
import { Elements as Components } from 'circuit-diagram';

import ComponentSelector from '../src/ComponentSelector.js';

const COLORS = Theme.COLORS;
const { lineHeight, fontSize, fontFamily } = Theme.TYPOGRAPHY;

const style = {
  width: '250px',

  position: 'absolute',
  top: 0,
  left: 0,
  bottom: 0
};

const onButtonClicked = buttonID => {
  console.log('button clicked:', buttonID); //eslint-disable-line
};

ReactDOM.render(
  <div>
    <Style
      rules={{
        '*': {
          lineHeight,
          fontSize,
          fontFamily,
          backgroundColor: COLORS.background,
          color: COLORS.base
        }
      }}
    />
    <ComponentSelector theme={ Theme } style={ style } onButtonClicked={ onButtonClicked } selectedButton={ Components.Wire.typeID } />
  </div>,
  document.getElementById('circuitsim')
);
