'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _parseunit3 = require('parseunit');

var _parseunit4 = _interopRequireDefault(_parseunit3);

var _ArtWrapperJs = require('./ArtWrapper.js');

var _ArtWrapperJs2 = _interopRequireDefault(_ArtWrapperJs);

function styles(_ref) {
  var COLORS = _ref.COLORS;
  var TYPOGRAPHY = _ref.TYPOGRAPHY;

  var vars = {
    imgSize: 50,
    paddingH: 5,
    paddingV: 1
  };

  var _parseunit = (0, _parseunit4['default'])(TYPOGRAPHY.lineHeight);

  var _parseunit2 = _slicedToArray(_parseunit, 2);

  var lhVal = _parseunit2[0];
  var lhUnits = _parseunit2[1];

  return {
    button: {
      padding: vars.paddingV + 'px ' + vars.paddingH + 'px',
      border: 'none',
      width: vars.imgSize + 2 * vars.paddingH + 'px',
      ':hover': {}
    },
    img: {
      height: vars.imgSize + 'px',
      width: vars.imgSize + 'px',
      marginLeft: 'auto',
      marginRight: 'auto'
    },
    label: {
      height: '' + 2 * lhVal + lhUnits,
      display: 'inline-block',
      verticalAlign: 'top'
    },
    base: {
      color: COLORS.base
    },
    hover: {
      color: COLORS.highlight
    },
    selected: {
      color: COLORS.theme
    }
  };
}

var Button = (function (_React$Component) {
  _inherits(Button, _React$Component);

  function Button(props) {
    _classCallCheck(this, Button);

    _get(Object.getPrototypeOf(Button.prototype), 'constructor', this).call(this, props);
    this.onClick = this.onClick.bind(this);
  }

  _createClass(Button, [{
    key: 'onClick',
    value: function onClick() {
      this.props.onClick(this.props.id);
    }
  }, {
    key: 'render',
    value: function render() {
      var styled = styles(this.props.theme);
      var labelColor = _radium2['default'].getState(this.state, 'button', ':hover') ? styled.hover : styled.base;
      var imgColor = this.props.selected ? styled.selected : labelColor;

      return _react2['default'].createElement(
        'button',
        {
          key: 'button',
          onClick: this.onClick,
          style: styled.button,
          type: 'button',
          name: this.props.name,
          value: this.props.name },
        _react2['default'].createElement(
          'div',
          { style: styled.img },
          _react2['default'].createElement(_ArtWrapperJs2['default'], _extends({
            art: this.props.art,
            theme: this.props.theme
          }, imgColor))
        ),
        _react2['default'].createElement(
          'span',
          { style: [styled.label, labelColor] },
          this.props.name
        )
      );
    }
  }]);

  return Button;
})(_react2['default'].Component);

Button.propTypes = {
  id: _react2['default'].PropTypes.string.isRequired,
  name: _react2['default'].PropTypes.string.isRequired,
  art: _react2['default'].PropTypes.any.isRequired,
  selected: _react2['default'].PropTypes.bool,
  theme: _react2['default'].PropTypes.object.isRequired,

  onClick: _react2['default'].PropTypes.func.isRequired
};

Button.defaultProps = {
  selected: false
};

exports['default'] = (0, _radium2['default'])(Button);
module.exports = exports['default'];