'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsCreateFragment = require('react-addons-create-fragment');

var _reactAddonsCreateFragment2 = _interopRequireDefault(_reactAddonsCreateFragment);

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _circuitDiagram = require('circuit-diagram');

var _ButtonJs = require('./Button.js');

var _ButtonJs2 = _interopRequireDefault(_ButtonJs);

var _ButtonGroupJs = require('./ButtonGroup.js');

var _ButtonGroupJs2 = _interopRequireDefault(_ButtonGroupJs);

var _artMouseJs = require('./art/Mouse.js');

var _artMouseJs2 = _interopRequireDefault(_artMouseJs);

var PropTypes = _react2['default'].PropTypes;

var baseButtons = {
  select: {
    name: 'Select',
    art: _artMouseJs2['default']
  }
};

function camelToSpace(string) {
  return _ramda2['default'].replace(/([a-z\d])([A-Z])/g, '$1 $2', string);
}

var BUTTONS = _ramda2['default'].reduce(function (buttons, component) {
  return _ramda2['default'].assoc(component.typeID, {
    name: camelToSpace(component.typeID),
    art: component
  }, buttons);
}, baseButtons, _ramda2['default'].values(_circuitDiagram.Elements));

var GROUPS = {
  mouse: {
    name: 'Mouse',
    buttons: ['select']
  },
  components: {
    name: 'Components',
    buttons: _ramda2['default'].keys(_circuitDiagram.Elements)
  }
};

var ComponentSelector = (function (_React$Component) {
  _inherits(ComponentSelector, _React$Component);

  function ComponentSelector(props) {
    _classCallCheck(this, ComponentSelector);

    _get(Object.getPrototypeOf(ComponentSelector.prototype), 'constructor', this).call(this, props);
    this.toButtonGroups = this.toButtonGroups.bind(this);
    this.toButtons = this.toButtons.bind(this);
  }

  _createClass(ComponentSelector, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return { disableCurrent: true };
    }
  }, {
    key: 'toButtons',
    value: function toButtons(buttonIDs) {
      var _props = this.props;
      var selectedButton = _props.selectedButton;
      var onButtonClicked = _props.onButtonClicked;
      var theme = _props.theme;

      return _ramda2['default'].map(function (buttonID) {
        var props = _ramda2['default'].pipe(_ramda2['default'].assoc('id', buttonID), _ramda2['default'].assoc('onClick', onButtonClicked))(BUTTONS[buttonID]);
        return _react2['default'].createElement(_ButtonJs2['default'], _extends({ key: props.id }, props, { theme: theme, selected: selectedButton === buttonID }));
      }, buttonIDs);
    }
  }, {
    key: 'toButtonGroups',
    value: function toButtonGroups(groupProperties) {
      var buttons = this.toButtons(groupProperties.buttons);

      return _react2['default'].createElement(
        _ButtonGroupJs2['default'],
        {
          key: groupProperties.name,
          name: groupProperties.name,
          theme: this.props.theme
        },
        buttons
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var groups = (0, _reactAddonsCreateFragment2['default'])(_ramda2['default'].mapObj(this.toButtonGroups, GROUPS));

      return _react2['default'].createElement(
        'div',
        { style: this.props.style },
        groups
      );
    }
  }]);

  return ComponentSelector;
})(_react2['default'].Component);

exports['default'] = ComponentSelector;

ComponentSelector.propTypes = {
  theme: PropTypes.object.isRequired,
  style: PropTypes.object,

  selectedButton: PropTypes.string.isRequired,

  onButtonClicked: PropTypes.func.isRequired
};

ComponentSelector.defaultProps = {
  selectedButton: 'select',
  onButtonClicked: function onButtonClicked() /* buttonID */{}
};

ComponentSelector.childContextTypes = {
  disableCurrent: _react2['default'].PropTypes.bool.isRequired
};
module.exports = exports['default'];