'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactArt = require('react-art');

var _immutableVector2d = require('immutable-vector2d');

var _immutableVector2d2 = _interopRequireDefault(_immutableVector2d);

var _circuitsimArtUtils = require('circuitsim-art-utils');

var STEM_SIZE = new _immutableVector2d2['default'](6, 15);
var ARROW_LENGTH = 42;
var THING_LENGTH = 15;

var Mouse = (function (_React$Component) {
  _inherits(Mouse, _React$Component);

  function Mouse() {
    _classCallCheck(this, Mouse);

    _get(Object.getPrototypeOf(Mouse.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Mouse, [{
    key: 'render',
    value: function render() {
      var _props$connectors = _slicedToArray(this.props.connectors, 2);

      var tl = _props$connectors[0];
      var br = _props$connectors[1];
      var tr = new _immutableVector2d2['default'](br.x, tl.y);

      var topPoint = tl.mix(tr, 0.25).snap(1); // snap to prevent blurriness

      var bottomPoint = topPoint.add(new _immutableVector2d2['default'](0, ARROW_LENGTH));

      var stemTL = bottomPoint.add(new _immutableVector2d2['default'](1, -1).normalize(THING_LENGTH));
      var stemBL = stemTL.add(STEM_SIZE);
      var stemBR = stemBL.add(new _immutableVector2d2['default'](4, -2));
      var stemTR = stemBR.subtract(STEM_SIZE);

      var rightPoint = stemTR.add(new _immutableVector2d2['default'](THING_LENGTH, 0));

      var path = new _reactArt.Path().moveTo(topPoint.x, topPoint.y).lineTo(bottomPoint.x, bottomPoint.y).lineTo(stemTL.x, stemTL.y).lineTo(stemBL.x, stemBL.y).lineTo(stemBR.x, stemBR.y).lineTo(stemTR.x, stemTR.y).lineTo(rightPoint.x, rightPoint.y).close();

      return _react2['default'].createElement(_reactArt.Shape, {
        strokeWidth: this.props.theme.ART.LINE_WIDTH,
        stroke: this.props.color,
        strokeJoin: 'round',
        d: path
      });
    }
  }]);

  return Mouse;
})(_react2['default'].Component);

exports['default'] = Mouse;

Mouse.propTypes = {
  connectors: _react2['default'].PropTypes.arrayOf(_circuitsimArtUtils.Utils.PropTypes.Vector).isRequired,
  color: _react2['default'].PropTypes.string.isRequired,
  theme: _react2['default'].PropTypes.object.isRequired
};
module.exports = exports['default'];